<?php
header('Access-Control-Allow-Origin: *');
require_once __DIR__ . '/../util/Funciones.clase.php';
require_once __DIR__ . '/../negocio/Viaje.clase.php';
date_default_timezone_set("America/Lima");

require_once __DIR__ . '/../util/definiciones.php';
require_once __DIR__ . '/../util/sendgrid-php/vendor/autoload.php';


if (
    !isset($_POST["viajeTipoDetalle"])
    || !isset($_POST["viajeEmpleadoDetalle"])
    || !isset($_POST["viajeDetalle"])
    ) {
    return Funciones::imprimeJSON(200, "error", "Faltan parámetros");
}

try{
    $viajeTipoDetalle = json_decode($_POST["viajeTipoDetalle"], true);
    $viajeEmpleadoDetalle = json_decode($_POST["viajeEmpleadoDetalle"], true);
    $viajeDetalle = json_decode($_POST["viajeDetalle"], true);

    $obj = new Viaje();
    $resultado = $obj->sincronizarViaje($viajeTipoDetalle, $viajeEmpleadoDetalle, $viajeDetalle);
    Funciones::imprimeJSON(200, "lista viajes", $resultado);
}catch(Exception $e){
    $fecha_servidor = date("d/m/Y") . ' ' . date("H:i:s");
    $rojo = "POST -> sincronizar.viaje.movil.php";
    $motivo_rojo = "<strong>Viaje : </strong>".json_encode($viajeDetalle)."<br>". "<strong>Viaje tipo: </strong>". json_encode($viajeTipoDetalle) ."<br>". "<strong>Viaje empleado: </strong>". json_encode($viajeEmpleadoDetalle);
    $mensaje = "A continuación se detallan los datos de envío para la sincronización de viajes: ";
    $htmlFileDiv = __DIR__ . '/../plantilla/correo/inner_box.html';
    $innerHtml = file_get_contents($htmlFileDiv);
    $innerHtml = str_replace("{{rojo}}", $rojo, $innerHtml);
    $innerHtml = str_replace("{{resultado}}", $e->getMessage(), $innerHtml);
    $innerHtml = str_replace("{{motivo_rojo}}", $motivo_rojo, $innerHtml);
    $innerHtml = str_replace("{{fecha_server}}", $fecha_servidor, $innerHtml);

    $htmlFile = __DIR__ . '/../plantilla/correo/plantilla_general.html';
    $html = file_get_contents($htmlFile);
    $html = str_replace("{{Mensaje}}", $mensaje, $html);
    $html = str_replace("{{inner_html}}", $innerHtml, $html);

    $email = new \SendGrid\Mail\Mail();
    $email->setFrom("area.sistemas@proolmos.pe", "Pro Olmos");
    $email->setSubject("Error aplicativo transportistas");
    // $email->addTo("jchancafe@proolmos.pe");
    $email->addTo("rvasquez@proolmos.pe");
    $email->addContent(
        "text/html",
        $html
    );
    $sendgrid = new \SendGrid(SENDGRID_API_KEY);
    try {
        $response = $sendgrid->send($email);
        $envio_correo = $response->statusCode();
    } catch (Exception $e) {
        $envio_correo = 500;
    }
    //enviar correo con $detalle

    //Enviar mensaje de texto
    $telefono = "969105301";
    $mensaje = "Error en el aplicativo de transportistas, sincronizado de viajes. Revise su correo. ".$fecha_servidor;
    $mensaje = utf8_decode($mensaje);
    $url_holder_sms = str_replace(' ', '%20', "http://servicio.smsmasivos.com.ar/enviar_sms.asp?api=1&usuario=PROOLMOS&clave=PROOLMOS352&tos=" . $telefono . "&texto=" . $mensaje);
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url_holder_sms);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    $data = curl_exec($ch);
    curl_close($ch);

    Funciones::imprimeJSON(200, "error", $e->getMessage());
}
