<?php

require_once __DIR__ . '/configuracion.php';
require_once __DIR__ . '/../util/Funciones.clase.php';

class Conexion
{
    protected $dblink;

    public function __construct()
    {
        $this->abrirConexion();
    }

    public function __destruct()
    {
        $this->dblink = null;
    }

    protected function abrirConexion()
    {
        try {
            if (getenv('POSTGRES_DSN')) {
                $dsn = getenv('POSTGRES_DSN');
                $user = getenv('POSTGRES_USER');
                $password = getenv('POSTGRES_PASSWORD');
            } else {
                $dsn = "pgsql:host=" . POSTGRES_HOST . ";dbname=" . POSTGRES_DB . ";port=" . POSTGRES_PORT;
                $user = POSTGRES_USER;
                $password = POSTGRES_PASSWORD;
            }

            $this->dblink = new PDO($dsn, $user, $password);
            $this->dblink->exec("SET NAMES 'utf8'");
            $this->dblink->exec("SET lc_time_names = 'es_PE'");
            $this->dblink->exec("SET time_zone = '-05:00'");
            $this->dblink->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

        } catch (PDOException $exc) {
            Funciones::imprimeJSON(500, $exc->getMessage(), "e");
        }

        return $this->dblink;
    }
}
?>
