<?php
require __DIR__.'/../datos/Conexion.clase.php';
require __DIR__ . '/../util/definiciones.php';
date_default_timezone_set("America/Lima");

class Empleado extends Conexion {
    public function buscarEmpleadoDni($dni){
        try {
            $sql = "SELECT
                        e.*,
                        (
                            coalesce(
                                (select estado from empleado_empresa where codigo_empleado = e.codigo_empleado limit 1),
                                'A'
                                )
                            ) as estado
                    FROM
                        empleado as e
                    WHERE
                        numero_documento = ?;";
            $sentencia = $this->dblink->prepare($sql);
            $sentencia->bindParam(1, $dni);
            $sentencia->execute();
            $resultado = $sentencia->fetch(PDO::FETCH_ASSOC);
            if(!$sentencia->rowCount()){
                $resultado = [];
            }
            return $resultado;
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function buscarReniec($dni)
    {
        $json = '{CODDNI: "' . $dni . '"}';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, CONSULTA_JNE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
        curl_setopt($ch, CURLOPT_HEADER, TRUE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json", "RequestVerificationToken: " . TOKEN_JNE));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

        $head = curl_exec($ch);
        curl_close($ch);

        $porciones = explode("GMT", $head);
        $ultimo_elemento = count($porciones) - 1;
        $respuesta = json_decode($porciones[$ultimo_elemento], TRUE);

        if (isset($respuesta["data"])) {
            $respuesta = explode("|", $respuesta["data"]);

            if ($respuesta[0] == "" && $respuesta[1] == "" && $respuesta[2] == "") {
                /* Si no fue encontrado en RENIEC se regresa un array vacío */
                $resultado = $this->personalNuevo($dni);
                /* Si no fue encontrado en RENIEC se regresa un array vacío */
            } else {
                $resultado["codigo_empleado"] = 0;
                $resultado["numero_documento"] = $dni;
                $resultado["apellido_paterno"] = $respuesta[0];
                $resultado["apellido_materno"] = $respuesta[1];
                $resultado["nombre"] = $respuesta[2];
                $resultado["estado"] = 'A';
            }
        } else {
            //NO ENCONTRADO
            $resultado = $this->personalNuevo($dni);
        }
        return $resultado;
    }

    public function personalNuevo($dni)
    {
        $resultado["codigo_empleado"] = 0;
        $resultado["numero_documento"] = $dni;
        $resultado["nombre"] = "PERSONAL NUEVO";
        $resultado["apellido_paterno"] = "";
        $resultado["apellido_materno"] = "";
        $resultado["estado"] = "A";
        return $resultado;
    }
}